/*
 ai.hpp
 Katsuki Ohto
 */

#ifndef AIWOLF_AI_HPP_
#define AIWOLF_AI_HPP_

# include "aiwolf.hpp"

// AIベース
// ランダムな行動を取る

namespace AIWolf{
    class AI{
    public:
        
        AI():dice(seed()){
            setName("Default");
            setHopeRole(NONE_ROLE);
        }
        
        virtual void setName(const std::string& nm){
            name_ = nm;
        }
        virtual void setHopeRole(const int r){
            hopeRole_ = r;
        }
        
        virtual std::string name()const{
            return name_;
        }
        virtual int hopeRole()const{
            return hopeRole_;
        }
        
        virtual void initialize(){}
        
        virtual void dailyInitialize(){}
        
        virtual void dailyFinish(){}
        
        virtual void finish(){}
        
        virtual Talk talk(){
            /*Talk talk;
            talk.clear();
            talk.setType(dice() % N_TALKTYPES);
            switch(talk.type()){
                case VOTE: case GUARDED: case ATTACK:{
                    talk.setDst(dice() % );
                }break;
                case COMINGOUT: ESTIMATE:{
                    oss << " " + toAgentString(stm.dst()) << " " << toRoleString(stm.role());
                }break;
                case DIVINED: INQUESTED:{
                    oss << " " + toAgentString(stm.dst()) << " " << toSpeciesString(stm.role());
                }break;
                case AGREE: DISAGREE:{
                    oss << " " << toCategoryString(stm.category());
                    oss << " " << "day" << stm.day() << " ID:" << stm.indexInDay();
                }break;
                default: break;
            }
            talk.setType(VOTE);
            talk.setDst(0);
            return talk;*/
            
            Talk *talk = new Talk[65536];
            int n = genAllStatements(talk, info(), TALK);
            int r = dice() % n;
            cerr << "rand = " << r << endl;
            Talk ret = talk[r];
            delete[] talk;
            return ret;
        }
        
        virtual Whisper whisper(){
            Whisper *whisper = new Whisper[65536];
            int n = genAllStatements(whisper, info(), WHISPER);
            int r = dice() % n;
            cerr << "rand = " << r << endl;
            Whisper ret = whisper[r];
            delete[] whisper;
            return ret;
        }
        
        virtual int vote(){
            return dice() % info().rule().players;
        }
        
        virtual int divine(){
            return dice() % info().rule().players;
        }
        
        virtual int guard(){
            return dice() % info().rule().players;
        }
        
        virtual int attack(){
            return dice() % info().rule().players;
        }
        
        virtual AgentInfo& info()noexcept{
            return info_;
        }
        
        virtual const AgentInfo& info()const noexcept{
            return info_;
        }
        
    private:
        std::string name_;
        int hopeRole_;
        std::random_device seed;
        std::mt19937 dice;
        AgentInfo info_;
    };
}

#endif // AIWOLF_AI_HPP_