//実験

#include <cstring>
#include <unistd.h>
#include <sys/time.h>
#include <ctime>

#include <cmath>
#include <cstdio>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cassert>
#include <random>
#include <algorithm>
#include <string>

#include "../defines.h"
#include "../util/bitOperation.hpp"
#include "../util/bitPartition.hpp"
#include "../util/xorShift.hpp"

using namespace std;

int main(){

    XorShift64 dice((unsigned int)time(NULL));
    Clock cl;

    //pext,pdep test
    constexpr int N = 500000;

    uint64 val[2] = { 0 };
    uint64 time[2] = { 0 };

    for (int i = 0; i < N; ++i){
        int numMask = 1 + dice.rand() % 64;

        uint64 bits = dice.rand();
        uint64 mask = pickNBits64(-1LL, numMask, 64 - numMask, &dice);

        uint64 ans;

        cl.start();

        {
            /*if (mask){
                int a = bsr(mask);
                ans = (bits >> a) & 1;
                uint64 tmask = mask - (1ULL << a);
                while (tmask){
                    ans <<= 1;
                    int a = bsr(tmask);
                    ans |= (bits >> a) & 1;
                    tmask -= (1ULL << a);
                }
            }
            else{
                ans = 0;
            }*/
            
            if (mask){
                int a = bsf(mask);
                ans = (bits >> a) & 1;
                uint64 tmask = mask & (mask - 1ULL);
                if (tmask){
                    int cnt = 1;
                    while (1){
                        int a = bsf(tmask);
                        ans |= ((bits >> a) & 1) << cnt;
                        tmask &= (tmask - 1ULL);
                        if (!tmask)break;
                        ++cnt;
                    }
                }
            }
            else{
                ans = 0;
            }
        }
        time[1] += cl.stop();
        val[1] ^= ans;

        cl.start();
        {
            ans = pext(bits, mask);
        }
        time[0] += cl.stop();
        val[0] ^= ans;

    }

    uint64 val1[2] = { 0 };
    uint64 time1[2] = { 0 };

    for (int i = 0; i < N; ++i){
        int numMask = 1 + dice.rand() % 64;

        uint64 bits = dice.rand();
        uint64 mask = pickNBits64(-1LL, numMask, 64 - numMask, &dice);

        uint64 ans;

        cl.start();

        {
            if (mask){
                int a = bsf(mask);
                ans = ((bits&1ULL)<<a);
                uint64 tmask = mask & (mask - 1ULL);
                uint64 tbits = bits >> 1;
                while (tmask){
                    int a = bsf(tmask);
                    ans |= ((tbits & 1ULL) << a);
                    tmask &= (tmask - 1ULL);
                    tbits >>= 1;
                }
            }
            else{
                ans = 0;
            }
        }
        time1[1] += cl.stop();
        val1[1] ^= ans;

        cl.start();
        {
            ans = pdep(bits, mask);
        }
        time1[0] += cl.stop();
        val1[0] ^= ans;

    }

    cerr << "pext" << endl;
    cerr << time[0] / N << endl;
    cerr << time[1] / N << endl;
    cerr << val[0] << endl;
    cerr << val[1] << endl;

    cerr << "pdep" << endl;
    cerr << time1[0] / N << endl;
    cerr << time1[1] / N << endl;
    cerr << val1[0] << endl;
    cerr << val1[1] << endl;

    //blsi test
    //uint64 r = dice.rand();

    //cerr << (r & (-r)) << endl;
    //cerr << (_blsi_u64(dice.rand())) << endl;

    return 0;
}