/*
io.hpp
Katsuki Ohto
*/

#ifndef UTIL_IO_HPP_
#define UTIL_IO_HPP_

#include <iostream>
#include <array>
#include <vector>

#include "../defines.h"

//出力簡略化
template<class T,unsigned long N>
std::ostream& operator<<(std::ostream& os, const std::array<T,N> arg){
    os << "{";
    for(int i=0; i<N-1; ++i){
        os << arg[i] << ",";
    }
    os << arg[N-1];
    os << "}" << std::endl;
    return os;
}

template<class T>
std::ostream& operator<<(std::ostream& os, const std::vector<T> arg){
    os << "{";
    for(int i=0; i<arg.size()-1; ++i){
        os << arg[i] << ",";
    }
    os << arg[arg.size()-1];
    os << "}" << std::endl;
    return os;
}


#endif // UTIL_IO_HPP_